您的位置:首页 > 其它

hdu 1069 (最长上升子序列)

2015-05-01 00:23 405 查看
Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana
by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions
of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly
smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,

representing the number of different blocks in the following data set. The maximum value for n is 30.

Each of the next n lines contains three integers representing the values xi, yi and zi.

Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0


Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342


很明显一看就得知道是最长上升子序列,可是序列并不是输入给你的,要你自己想怎样创造一个最长上升子序列,一定要是最长的,所以必须思考在怎样的序列中的最长上升子序列最长!看到了一种思路,就是对面积排序,这样的最长上升子序列一定最长。这题还有一个要注意的就是长宽高是可以任意改变的,所以得开个数组记录所有情况在排序。至于求最长上升的序列就不多说了看代码吧~:

#include <iostream>
#include <cstdio>
#include <cstring>
#include<algorithm>
using namespace std;
int dp[1000];
struct data
{
int x,y,z;
}q[1000];
bool cmp(data a,data b)
{
return a.x*a.y<b.x*b.y;
}
int main()
{
int n,o=1;
while(cin>>n&&n!=0)
{
int a,b,c,t=0;
for(int i=0;i<n;i++)
{
memset(dp,0,sizeof(0));
cin>>a>>b>>c;
if(a==b&&a==c)
{q[t].x=q[t].y=q[t].z=a;t++;}
else if(a==b&&a!=c)
{
q[t].x=q[t].y=a;q[t].z=c;t++;
q[t].x=q[t].z=a;q[t].y=c;t++;
q[t].z=q[t].y=a;q[t].x=c;t++;
}else if(a==c&&a!=b)
{
q[t].x=q[t].y=a;q[t].z=b;t++;
q[t].x=q[t].z=a;q[t].y=b;t++;
q[t].z=q[t].y=a;q[t].x=b;t++;
}else if(b==c&&b!=a)
{
q[t].x=q[t].y=b;q[t].z=a;t++;
q[t].x=q[t].z=b;q[t].y=a;t++;
q[t].z=q[t].y=b;q[t].x=a;t++;
}else
{
q[t].x=a;q[t].y=b;q[t].z=c;t++;
q[t].x=a;q[t].y=c;q[t].z=b;t++;
q[t].x=b;q[t].y=a;q[t].z=c;t++;
q[t].x=b;q[t].y=c;q[t].z=a;t++;
q[t].x=c;q[t].y=a;q[t].z=b;t++;
q[t].x=c;q[t].y=b;q[t].z=a;t++;
}
}
sort(q,q+t,cmp);
for(int i=0;i<t;i++)
dp[i]=q[i].z;
int max0=-1;
for(int i=0;i<t;i++)
{
for(int j=0;j<i;j++)
{
if(q[j].x<q[i].x&&q[j].y<q[i].y)
dp[i]=max(dp[i],dp[j]+q[i].z);
if(dp[i]>max0)max0=dp[i];
}
}
//  for(int i=0;i<t;i++)
//    cout<<q[i].x<<' '<<q[i].y<<' '<<q[i].z<<' '<<"dp="<<dp[i]<<endl;
cout<<"Case "<<o++<<": maximum height = "<<max0<<endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: